<script setup lang="ts">
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------

import { useConnectionStore } from "@/stores/useConnectionStore";
import { useSubmissionStore } from "@/stores/useSubmissionStore";

// ----------------------------------------------------------------
// Props
// ----------------------------------------------------------------

defineProps({
  search: {
    type: String,
    required: true,
  },
});

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

// Initialize the stores
const submissionStore = useSubmissionStore();
const connectionStore = useConnectionStore();
const workspaceStore = useWorkspaceStore();

const loadingSubmission = ref(false);
const submissionItems = ref([]);

// Define table headers
const headers = [
  { title: "Title", value: "title", width: "30%", sortable: true },
  { title: "Repository", value: "connectionID", width: "30%" },
  { title: "Status", value: "status", width: "20%", sortable: true },
  { title: "Last Modification", value: "lastEditedTime", width: "30%" },
];

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

function openSubmission(event, row) {
  navigateTo(`/${workspaceStore.currentWSlug}/submissions-${row.internalItem.key}`);
}

/**
 * Format an ISO date string to a human-readable date format.
 * @param {string} isoString - The ISO date string to format.
 * @returns {string} - The formatted date string.
 */
function formatDate(isoString: string) {
  const date = new Date(isoString);
  return new Intl.DateTimeFormat("en-GB", {
    year: "numeric",
    month: "short",
    day: "numeric",
    hour: "numeric",
    minute: "numeric",
    hour12: true, // Enable 12-hour format with AM/PM
  }).format(date);
}

/**
 * Fetch submissions and map the results into `submissionItems`.
 * This function handles the asynchronous fetching of workspace, connections, and submissions
 * and populates the submission table with connector information.
 * It also manages the loading state during the data-fetching process.
 */
async function fetchSubmissionData() {
  try {
    loadingSubmission.value = true;
    await workspaceStore.fetchWorkspaces();

    // Fetch connections
    await connectionStore.fetchConnections();

    await submissionStore.fetchSubmissions();
    const submissions = Array.from(submissionStore.submissionMap.values());

    // Map submission items with connector names for display
    submissionItems.value = submissions.map((submission) => {
      const connection = connectionStore.getConnection(submission.connectionID);
      return {
        ...submission,
        connectorName: connection?.connector?.name,
        connectorStatusColor: connectionStore.getStatus(connection.id, connection.status),
      };
    });
  } finally {
    loadingSubmission.value = false;
  }
}

// ----------------------------------------------------------------
// OnMounted
// ----------------------------------------------------------------

onMounted(async () => {
  await fetchSubmissionData();
});
</script>

<template>
  <v-container fluid class="pa-0">
    <v-row no-gutters>
      <v-data-table
        :headers="headers"
        :items="submissionItems"
        item-key="id"
        class="elevation-1 fill-height"
        :loading="loadingSubmission"
        :search="search"
        @click:row="openSubmission"
      >
        <!-- Title column -->
        <template v-slot:[`item.title`]="{ item }">
          <span style="font-weight: bold">{{ item.title }}</span>
        </template>

        <!-- Repository column -->
        <template v-slot:[`item.connectionID`]="{ item }">
          <v-icon
            :color="item.connectorStatusColor.hex"
            size="16px"
            class="me-2"
          >
            mdi-circle
          </v-icon>
          <span>{{ item.connectorName }}</span>
        </template>

        <!-- Status column with badge -->
        <template v-slot:[`item.status`]="{ item }">
          <v-chip :color="submissionStore.getStatusBadge(item.status).color" dark>
            <span style="font-weight: bold">
              {{ submissionStore.getStatusBadge(item.status).label }}
            </span>
          </v-chip>
        </template>
        <!-- Date column -->
        <template v-slot:[`item.lastEditedTime`]="{ item }">
          {{ formatDate(item.lastEditedTime) }}
        </template>
      </v-data-table>
    </v-row>
  </v-container>
</template>
